<?php /*** Install necessary database tables on activation**/
global $ovis_db_version;
$ovis_db_version = '1.0';
function ovis_db_install() {
	global $wpdb;	global $ovis_db_version;
	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	$tblNameSettings = OVIS_DB_PREFIX . "ovis";    /* Create settings table */
	$sqlCreateSettingsTable = "CREATE TABLE IF NOT EXISTS `".$tblNameSettings."` (		OVIS_id mediumint(9) NOT NULL AUTO_INCREMENT,        OVIS_authentication varchar(100) NOT NULL DEFAULT '0',        OVIS_button_bg_color varchar(7) NOT NULL DEFAULT '#DFDFDF',        OVIS_button_text_color varchar(7) NOT NULL DEFAULT '#333333',        OVIS_object_bg_color varchar(7) NOT NULL DEFAULT '#DFDFDF',        OVIS_object_text_color varchar(7) NOT NULL DEFAULT '#333333',		        OVIS_items_per_page int(3) NOT NULL DEFAULT '12',        OVIS_items_per_page_no_filter int(3) NOT NULL DEFAULT '12',		OVIS_items_per_row int(1) NOT NULL DEFAULT '3',		        OVIS_bg_color varchar(7) NOT NULL DEFAULT '#f6f6f6',        OVIS_text_color varchar(7) NOT NULL DEFAULT '#333333',		PRIMARY KEY (OVIS_id)        ) DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci    ";
	dbDelta($sqlCreateSettingsTable);
	$tblNameSessions = OVIS_DB_PREFIX . "ovis_sessions";	 /* Create sessions table */    $sqlCreateSessionsTable = "CREATE TABLE IF NOT EXISTS `".$tblNameSessions."` (		OVIS_session_key varchar(100) NOT NULL DEFAULT '0',        OVIS_session_date DATETIME NULL,        OVIS_session_data TEXT NULL,		UNIQUE `sessionKey` (`OVIS_session_key`)        ) DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci    ";
	dbDelta($sqlCreateSessionsTable);
	add_option('ovis_db_version', $ovis_db_version);}
/*** Insert row**/
function ovis_data_install() {
	global $wpdb;
	$tblNameSettings = OVIS_DB_PREFIX . "ovis";	
	$sQuery = "INSERT INTO `".$tblNameSettings."` (`OVIS_id`) values ('1') ON DUPLICATE KEY UPDATE `OVIS_id`='1'";
	if(!$stmt = $wpdb->dbh->prepare($sQuery)) {		
	} else {		$sResult = $wpdb->dbh->query($sQuery) or trigger_error(mysqli_error($wpdb->dbh), E_USER_ERROR);		}	}
/*** Delete database tables on uninstall**/
function ovis_db_uninstall() {	
    global $wpdb;
    $tblNameSettings = OVIS_DB_PREFIX . OVIS_PLUGIN_SLUG; 
    /* Delete settings table */   $sqlDeleteSettingsTable = "DROP TABLE IF EXISTS `".$tblNameSettings."`";    $wpdb->query($sqlDeleteSettingsTable);
	$tblNameSessions = OVIS_DB_PREFIX . OVIS_PLUGIN_SLUG."_sessions";    /* Delete sessions table */    $sqlDeleteSessionsTable = "DROP TABLE IF EXISTS `".$tblNameSessions."`";    $wpdb->query($sqlDeleteSessionsTable);
    delete_option('ovis_db_version');
}
/*** Register plugin menu* * OVIS_PAGE_SLUG_1 = general* OVIS_PAGE_SLUG_2 = design* OVIS_PAGE_SLUG_3 = integration* OVIS_PAGE_SLUG_4 = settings* OVIS_PAGE_SLUG_5 = appearance**/
function register_menu() {
	add_menu_page(
        OVIS_PLUGIN_NAME, 
        OVIS_PLUGIN_NAME, 
        'manage_options', 
        OVIS_PLUGIN_SLUG . '-' . OVIS_PAGE_SLUG_1,
        'page_' . OVIS_PAGE_SLUG_1,
		plugin_dir_url( __FILE__ ) . '../assets/img/plugin-icon.png' 
    );
	add_submenu_page(
        OVIS_PLUGIN_SLUG . '-' . OVIS_PAGE_SLUG_1,
        OVIS_PAGE_NAME_1, 
        OVIS_PAGE_NAME_1, 
        'manage_options', 
        OVIS_PLUGIN_SLUG . '-' . OVIS_PAGE_SLUG_1,
        'page_' . OVIS_PAGE_SLUG_1
    );
	add_submenu_page(
        OVIS_PLUGIN_SLUG . '-' . OVIS_PAGE_SLUG_1,
        OVIS_PAGE_NAME_2, 
        OVIS_PAGE_NAME_2,
        'manage_options', 
        OVIS_PLUGIN_SLUG . '-' . OVIS_PAGE_SLUG_2,
        'page_' . OVIS_PAGE_SLUG_2
    );
    add_submenu_page(
        OVIS_PLUGIN_SLUG . '-' . OVIS_PAGE_SLUG_1,
        OVIS_PAGE_NAME_3, 
        OVIS_PAGE_NAME_3, 
        'manage_options', 
        OVIS_PLUGIN_SLUG . '-' . OVIS_PAGE_SLUG_3,
        'page_' . OVIS_PAGE_SLUG_3
    );
    add_submenu_page(
        OVIS_PLUGIN_SLUG . '-' . OVIS_PAGE_SLUG_1,
        OVIS_PAGE_NAME_4, 
        OVIS_PAGE_NAME_4, 
        'manage_options', 
        OVIS_PLUGIN_SLUG . '-' . OVIS_PAGE_SLUG_4,
        'page_' . OVIS_PAGE_SLUG_4
    );
    add_submenu_page(
        OVIS_PLUGIN_SLUG . '-' . OVIS_PAGE_SLUG_1,
        OVIS_PAGE_NAME_5, 
        OVIS_PAGE_NAME_5, 
        'manage_options', 
        OVIS_PLUGIN_SLUG . '-' . OVIS_PAGE_SLUG_5,
        'page_' . OVIS_PAGE_SLUG_5
    );        
}
/*
*
* Does the user have sufficient permission?
*
*/
function user_permissions() {
    if (!current_user_can('manage_options')) {
        wp_die(__('You do not have sufficient permissions to access this page.'));
    }
}
/**
* General page
*
*/
function page_general() {	
    user_permissions();
    require(plugin_dir_path(__FILE__) . 'inc_page_general.php');
}
/*
*
* Design page
*
*/
function page_design() {
    user_permissions();
	global $oForms;
    require(plugin_dir_path(__FILE__) . 'inc_page_design.php');	
}
/*
*
* Integration page
*
*/
function page_integration() {
    user_permissions();
    global $oData;
	global $oForms;
    require(plugin_dir_path(__FILE__) . 'inc_page_integration.php');
}
/*** Settings page*
*/
function page_settings() {
    user_permissions();
    global $oForms;
    require(plugin_dir_path(__FILE__) . 'inc_page_settings.php');
} 
/*
*
* Appearance page
*
*/
function page_appearance() {
    user_permissions();
    global $oForms;
    require(plugin_dir_path(__FILE__) . 'inc_page_appearance.php');	
}
/*
*
* Translation page
*
*/
function page_translation() {
    user_permissions();
    global $oForms;
    require(plugin_dir_path(__FILE__) . 'inc_page_translation.php');	
}
function getOVISTranslation($sLanguage){
	switch($sLanguage){	
		case 'de':
		case 'de_DE':
		case 'de_CH':
			return 'de_DE';
		case 'en':
		case 'en_US':
		case 'en_GB':
		case 'en_CA':
		case 'en_AU':
			return 'en_EN';
		case 'fr':
		case 'fr_FR':
			return 'fr_FR';
		default:
			return 'nl_NL';			
	}	
}
/*
*
* Load language file
*
*/
function userLanguage() {
    global $language;
    $file = plugin_dir_path(__FILE__) . 'language/' . $language . '.ini';
    if(!file_exists($file)) {
        		return '<p>Sorry, something went wrong</p>';
      }
    return parse_ini_file($file);
}
/*
*
* Rewrite rules
*
*/
function add_output_rewrite() {
	function output_query_vars($vars) {
		$vars[] = 'page';
		$vars[] = 'ovis_category';
		$vars[] = 'ovis_object_id';
		return $vars;
	}
	add_filter('query_vars', 'output_query_vars');
	$page_on_front = get_option('page_on_front');
	$rules  = add_rewrite_rule(		'^([0-9]+)/?$',		'index.php?page=$matches[1]',		'top'			);
	$rules .= add_rewrite_rule(		'^([^/]+)/([0-9]+)/?$', 		'index.php?pagename=$matches[1]&page=$matches[2]',		'top'	);
	$rules .= add_rewrite_rule(		'^details/([^/]+)/([^/]+)/?$', 		'index.php?page_id=' . $page_on_front . '&display=odetails&ovis_category=$matches[1]&ovis_object_id=$matches[2]',		'top'	);	
	$rules .= add_rewrite_rule(
		'^([^/]+)/details/([^/]+)/([^/]+)/?$', 
		'index.php?pagename=$matches[1]&display=odetails&ovis_category=$matches[2]&ovis_object_id=$matches[3]',
		'top'	);
	$rules .= add_rewrite_rule(		'^([^/]+)/([^/]+)/details/([^/]+)/([^/]+)/?$', 		'index.php?pagename=$matches[1]/$matches[2]&display=odetails&ovis_category=$matches[3]&ovis_object_id=$matches[4]',		'top'	);	
	$rules .= add_rewrite_rule(
		'^([^/]+)/([^/]+)/([^/]+)/details/([^/]+)/([^/]+)/?$', 
		'index.php?pagename=$matches[1]/$matches[2]/$matches[3]&display=odetails&ovis_category=$matches[4]&ovis_object_id=$matches[5]',
		'top'	);
	return $rules;}
add_action('init', 'add_output_rewrite', 1);
/*** Disable canonical redirect (necessary for output to work on frontpage)**/
function disable_canonical_redirect_for_front_page($redirect) {	if(is_page() && $front_page = get_option('page_on_front')) {
		if (is_page($front_page)) {
			$redirect = false;
		}
	}
	return $redirect;
}
add_filter('redirect_canonical', 'disable_canonical_redirect_for_front_page');
add_filter('plugins_api', 'ovis_plugin_info', 20, 3);
/*
 * $res empty at this step
 * $action 'plugin_information'
 * $args stdClass Object ( [slug] => woocommerce [is_ssl] => [fields] => Array ( [banners] => 1 [reviews] => 1 [downloaded] => [active_installs] => 1 ) [per_page] => 24 [locale] => en_US ) */
function ovis_plugin_info( $res, $action, $args ){	if( 'plugin_information' !== $action ) {
		return false;		
	}
	$plugin_slug = 'ovis/index.php';
	if( $plugin_slug !== $args->slug ) {
		return false;		
	}	
	if( false == $remote = get_transient( 'ovis_update_' . $plugin_slug ) ) {		$remote = wp_remote_get( OVIS_REPOSITORY_URL.'/include/inc.json.php', array(
			'timeout' => 10,
			'headers' => array(
				'Accept' => 'application/json'
			) 		)
		);		
		if ( ! is_wp_error( $remote ) && isset( $remote['response']['code'] ) && $remote['response']['code'] == 200 && ! empty( $remote['body'] ) ) {
			set_transient( 'ovis_update_' . $plugin_slug, $remote, 43200 ); /* 12 hours cache */
		}
	}
	if( ! is_wp_error( $remote ) && isset( $remote['response']['code'] ) && $remote['response']['code'] == 200 && ! empty( $remote['body'] ) ) {
		$remote = json_decode( $remote['body'] );
		$res = new stdClass();
		$res->name = $remote->name;
		$res->slug = $plugin_slug;
		$res->version = $remote->version;
		$res->tested = $remote->tested;
		$res->requires = $remote->requires;
		$res->author = $remote->author;
		$res->download_link = $remote->download_url;
		$res->trunk = $remote->download_url;
		$res->requires_php = $remote->requires_php;
		$res->last_updated = $remote->last_updated;
		$res->sections = array(
			'description' => $remote->sections->description,
			'installation' => $remote->sections->installation,
			'changelog' => $remote->sections->changelog
		);				if( !empty( $remote->sections->screenshots ) ) {
			$res->sections['screenshots'] = $remote->sections->screenshots;
		}
		if(isset($remote->banners->high) || isset($remote->banners->low)){ 
			$res->banners = array();
			if(isset($remote->banners->high)){ 
				$res->banners['high'] = $remote->banners->high;
			}
			if(isset($remote->banners->low)){ 
				$res->banners['low'] = $remote->banners->high;
			}
		}
		return $res;
	}
	return false;	
}
add_filter('site_transient_update_plugins', 'ovis_push_update' );
function ovis_push_update( $transient ){
	if ( empty($transient->checked ) ) {
		return $transient;
    }
	if( false == $remote = get_transient( 'ovis_index' ) ) {
		$remote = wp_remote_get( OVIS_REPOSITORY_URL.'/wp-plugin/json.php', array(
			'timeout' => 10,
			'headers' => array(
				'Accept' => 'application/json'
			) 		)
		);
		if ( !is_wp_error( $remote ) && isset( $remote['response']['code'] ) && $remote['response']['code'] == 200 && !empty( $remote['body'] ) ) {
			set_transient( 'ovis_index', $remote, 43200 ); /* 12 hours cache */
		}
	}
	if( $remote ) {	
		$remote = json_decode( $remote['body'] );		if( $remote && version_compare( OVIS_VERSION, $remote->version, '<' ) && version_compare($remote->requires, get_bloginfo('version'), '<' ) ) {
			$res = new stdClass();
			$res->slug = 'ovis/index.php';
			$res->plugin = 'ovis/index.php';
			$res->new_version = $remote->version;
			$res->tested = $remote->tested;
			$res->package = $remote->download_url;
						$transient->response[$res->plugin] = $res;
		}
	}
    return $transient;
}
/*
*
* Set title tag
*
*/
function ovis_overrule_title($title) {
	global $metaTitle404;
	if(!empty($metaTitle404)){		
		return $metaTitle404;		
	}
	$ovisUrlCategory = get_query_var('ovis_category');
	$ovisUrlObjectId = get_query_var('ovis_object_id');
	if(!empty($ovisUrlObjectId)){
		$metaData 		= explode('-', $ovisUrlObjectId);
		$metaLastKeys 	= array_keys($metaData);
		$metaLastPart   = end($metaLastKeys);
		$metaParts 		= '';		
		foreach($metaData as $key => $data) {
			if ($key == $metaLastPart) {
				$metaParts .= ucfirst($data);
			} else if($key > 0) {
				$metaParts .= ucfirst($data) . ' ';
			}			
		}
		$metaObject 	= str_replace('.html', '', $metaParts);
		$metaTitle  	= urldecode($metaObject) . ' - ' . get_bloginfo();
		if(!empty($ovisUrlCategory) && !empty($ovisUrlObjectId)) {
			$title = $metaTitle;
			return $title;			
		}
	}
	return $title;	
}	
add_filter('pre_get_document_title', 'ovis_overrule_title', 999, 1);
/*
*
* Check for active SEO plugin
*
*/
function ovis_check_seo_plugins_active() {
	/*
	*
	* wp-seo = Yoast SEO
	* all-in-one-seo-pack = All in One SEO Pack
	*
	*/
	$active_plugins = apply_filters('active_plugins', get_option('active_plugins'));	
	foreach($active_plugins as $plugin) {
		if(strpos($plugin, 'wp-seo') || strpos($plugin, 'all_in_one_seo_pack')) {
			return true;
		}	}
	return false;	
}
/*
** Set meta and og tags**/
function ovis_meta_tags() {
	global $metaTitle;	global $metaTitle404;	global $metaDescr;	global $metaCanonical;	global $sDetailImage;	global $wp_session;
	$ovisUrlCategory = get_query_var('ovis_category');
	$ovisUrlObjectId = get_query_var('ovis_object_id');
	if(!empty($ovisUrlObjectId)){
		$metaData 		= explode('-', $ovisUrlObjectId);
		$metaLastKeys 	= array_keys($metaData);
		$metaLastPart   = end($metaLastKeys);		$metaParts 		= '';
		foreach($metaData as $key => $data) {
			if ($key == $metaLastPart) {				$metaParts .= ucfirst($data);
			} else if($key > 0) {
				$metaParts .= ucfirst($data) . ' ';
			}
		}
		$sCusomCanoURL = get_home_url();		$sCusomCanoURL .= !empty($_SERVER['REQUEST_URI']) ? $_SERVER['REQUEST_URI'] : false;
				$metaObject 	= str_replace('.html', '', $metaParts);		$metaTitle  	= urldecode($metaObject) . ' - ' . get_bloginfo();
		$metaDescr 		= 'Bekijk deze ' . $ovisUrlCategory . ' ' . urldecode($metaObject) . ' bij ' . get_bloginfo();
		$metaKeywords	= ucfirst($ovisUrlCategory) . ', ' . str_replace(' ', ', ', urldecode($metaObject));
		$metaURL		= $sCusomCanoURL;
		$metaCanonical  = $sCusomCanoURL;
		$sDetailImage 	= false;		$aSessionKeys = array('checkdetails');
		addDataToSession($aSessionKeys,'');	
		if(!empty($ovisUrlCategory) && !empty($ovisUrlObjectId)) {
			if(!empty($wp_session['session_data']['sSettings'])){
				$oItemDetails = new data($wp_session['session_data']['sSettings'],false,1,false,false,'all',false,$ovisUrlObjectId,false,false);
				$oItemDetails->search_data(true);	
				$bIs404 = true;	
				if(!empty($oItemDetails->oObjectData)){	
					$oObjectData = json_decode($oItemDetails->oObjectData);									 
					if(!empty($oObjectData->result) && !empty($oObjectData->data)){
						$aSessionKeys = array('checkdetails');
						addDataToSession($aSessionKeys,base64_encode($oItemDetails->oObjectData));		
						if(!empty($oObjectData->data->data)){
							if(!empty($oObjectData->data->data[0])){
								$oObjectData = $oObjectData->data->data[0];
								if(!empty($oObjectData->presentation)){

									$bIs404 = false;										
									if(!empty($oObjectData->presentation->mediainfo)){
										if(!empty($oObjectData->presentation->mediainfo->images)){
											if(!empty($oObjectData->presentation->mediainfo->images[0])){
												$oObjectImages = $oObjectData->presentation->mediainfo->images[0];													
												$sDetailImage = $oObjectImages->traditional->original->default->url;												
											}									
										}									
									}									
								}
							}
						} 
					} 
				}
				if(!empty($bIs404)){
					$metaTitle404  	= 'Pagina niet gevonden - ' . get_bloginfo();
					$metaTitle  	= 'Pagina niet gevonden - ' . get_bloginfo();
					$metaDescr 		= 'Bekijk deze ' . $ovisUrlCategory . ' ' . urldecode($metaObject) . ' bij ' . get_bloginfo();					
					status_header(404);		
				}				
			}
			/*
			*
			* OVIS meta tags
			*
			*/
			$metaTags  = "\n";
			if(!ovis_check_seo_plugins_active()) {
				$metaTags .= "<!-- OVIS Meta Tags -->\n";
				$metaTags .= "<meta name=\"title\" content=\"" . $metaTitle . "\" />\n";
				$metaTags .= "<meta name=\"keywords\" content=\"" . $metaKeywords . "\" />\n";
				$metaTags .= "<meta name=\"description\" content=\"" . $metaDescr . "\" />\n";
				if(!empty($sDetailImage)){
					$metaTags .= "<meta property=\"og:image\" content=\"".$sDetailImage."\">";
					$metaTags .= "<meta property=\"og:image:width\" content=\"800\">";
					$metaTags .= "<meta property=\"og:image:width\" content=\"600\">";
				}
				$metaTags .= "<meta property=\"og:locale\" content=\"nl_NL\" />\n";
				$metaTags .= "<meta property=\"og:type\" content=\"website\" />\n";
				$metaTags .= "<meta property=\"og:title\" content=\"" . $metaTitle . "123456\" />\n";
				$metaTags .= "<meta property=\"og:description\" content=\"" . $metaDescr . "\" />\n";
				$metaTags .= "<meta property=\"og:url\" content=\"".get_permalink()."\" />\n";
				$metaTags .= "<meta property=\"og:site_name\" content=\"" . get_bloginfo() . "\" />\n";
				$metaTags .= "<meta name=\"twitter:card\" content=\"summary_large_image\" />\n";
				$metaTags .= "<meta name=\"twitter:description\" content=\"" . $metaDescr . "\" />\n";
				$metaTags .= "<meta name=\"twitter:title\" content=\"" . $metaTitle . "\" />\n";
			}			echo $metaTags;
			/*
			*
			* Replace YOAST SEO meta tags
			*
			*/
			function ovis_replace_ogtitle($title) {
				global $metaTitle;
				$title = $metaTitle;
				return $title;				
			}
			add_filter('wpseo_opengraph_title','ovis_replace_ogtitle', 999);
			function ovis_replace_ogdescription($description) {
				global $metaDescr;
				$description = $metaDescr;
				return $description;
			}
			add_filter('wpseo_opengraph_desc','ovis_replace_ogdescription', 999);
			function ovis_replace_ogimage($presentation) {
				global $sDetailImage;
				if (!empty($sDetailImage)) {
					$presentation->open_graph_images = [
						[
							'url' => $sDetailImage,
							'width' => 800,
							'height' => 600,
							'type' => 'image/jpeg'
						]
					];
				}
				return $presentation;				
			}
			add_filter('wpseo_frontend_presentation','ovis_replace_ogimage', 999);
			function ovis_replace_ogurl($url) {
				global $metaURL;
				$url = $metaURL;
				return $url;			}
			add_filter('wpseo_opengraph_url','ovis_replace_ogurl', 999);
			function ovis_replace_description($description) {
				global $metaDescr;
				$description = $metaDescr;
				return $description;
			}			
			add_filter('wpseo_metadesc','ovis_replace_description', 999);			
			function ovis_replace_canonical($canonical) {
				global $metaCanonical;
				$canonical = $metaCanonical;				
				return $canonical;
			}
			add_filter('wpseo_canonical','ovis_replace_canonical', 999);
			function ovis_replace_title($title) {
				global $metaTitle;
				$title = $metaTitle;
				return $title;
			}
			add_filter('wpseo_title','ovis_replace_title', 999);				}	}		}	
add_action('wp_head', 'ovis_meta_tags', 1);
/*** Clear de session table in de database**/
function clearSessionTable(){
	global $wpdb;
	global $wp_session;	
	if(isset($wp_session['session_data']['sSettings']['settings']['sessionclean'])){
		if(empty($wp_session['session_data']['sSettings']['settings']['sessionclean']) || $wp_session['session_data']['sSettings']['settings']['sessionclean'] < date('Y-m-d H:i:s',strtotime ( '-1 day' ))){
			$sQueryDelete = "DELETE from `".OVIS_DB_PREFIX."ovis_sessions` where `OVIS_session_date` < now() - interval 2 DAY;";
			$sResultDelete = $wpdb->dbh->query($sQueryDelete) or trigger_error(mysqli_error($wpdb->dbh), E_USER_ERROR);
			$dateNow = date('Y-m-d H:i:s');			
			$sQueryUpdate = "UPDATE " . OVIS_DB_PREFIX ."ovis SET OVIS_sessionclean = '" . $dateNow . "'	WHERE 1=1 AND OVIS_ID = 1";						
			$sResultUpdate = $wpdb->dbh->query($sQueryUpdate) or trigger_error(mysqli_error($wpdb->dbh), E_USER_ERROR);	
			$aSessionKeys = array('sSettings','settings','sessionclean');			
			addDataToSession($aSessionKeys,$dateNow);			
		}		
	}	
}
/*
*
* Start session
*
*/
function start_session(){
	global $wpdb;	global $wp_session;	
	check_database();
	if(session_status() != PHP_SESSION_ACTIVE){
		session_start();
		$sQuery = "SELECT * FROM `".OVIS_DB_PREFIX."ovis_sessions` WHERE 1=1 AND `OVIS_session_key` = '".(session_id())."' LIMIT 1;";
		if(!$stmt = $wpdb->dbh->prepare($sQuery)) {	
			/*$this->bSettingsError = true; */
		} else {							
			$sResult = $wpdb->dbh->query($sQuery) or trigger_error(mysqli_error($wpdb->dbh), E_USER_ERROR);			
			if(mysqli_num_rows($sResult) == 0){
				$sSessionID = session_id();
				if(empty($sSessionID)){
					$sSessionID = bin2hex(openssl_random_pseudo_bytes(32));
				}
				$sQuery = "INSERT INTO `".OVIS_DB_PREFIX."ovis_sessions` SET `OVIS_session_key` = '".($sSessionID)."',`OVIS_session_date` = '".(date('Y-m-d H:i:s'))."' ON DUPLICATE KEY UPDATE `OVIS_session_key` = '".($sSessionID)."';";
				if(!$stmt = $wpdb->dbh->prepare($sQuery)) {		
					/*$this->bSettingsError = true; */
				} else {							
					$sResult = $wpdb->dbh->query($sQuery) or trigger_error(mysqli_error($wpdb->dbh), E_USER_ERROR);
				}
				$wp_session = array();
				$wp_session['session_id'] = $sSessionID;
				$wp_session['session_data'] = false;
			} else {
				$sRow = mysqli_fetch_object($sResult);					
				$wp_session = !empty($sRow->OVIS_session_data) ? json_decode(base64_decode($sRow->OVIS_session_data),true) : array();
			}
		}		
		session_write_close();
	} else {
		$sQuery = "SELECT * FROM `".OVIS_DB_PREFIX."ovis_sessions` WHERE 1=1 AND `OVIS_session_key` = '".(session_id())."' LIMIT 1;";
		if(!$stmt = $wpdb->dbh->prepare($sQuery)) {	
			/*$this->bSettingsError = true; */
		} else {							
			$sResult = $wpdb->dbh->query($sQuery) or trigger_error(mysqli_error($wpdb->dbh), E_USER_ERROR);			
			if(mysqli_num_rows($sResult) == 0){
				$sSessionID = session_id();				
				if(empty($sSessionID)){
					$sSessionID = bin2hex(openssl_random_pseudo_bytes(32));
				}
				$sQuery = "INSERT INTO `".OVIS_DB_PREFIX."ovis_sessions` SET `OVIS_session_key` = '".($sSessionID)."',`OVIS_session_date` = '".(date('Y-m-d H:i:s'))."' ON DUPLICATE KEY UPDATE `OVIS_session_key` = '".($sSessionID)."';";
				if(!$stmt = $wpdb->dbh->prepare($sQuery)) {		
					/*$this->bSettingsError = true; */
				} else {							
					$sResult = $wpdb->dbh->query($sQuery) or trigger_error(mysqli_error($wpdb->dbh), E_USER_ERROR);
				}
				$wp_session = array();
				$wp_session['session_id'] = $sSessionID;
				$wp_session['session_data'] = false;				
			} else{
				$sRow = mysqli_fetch_object($sResult);
				$wp_session = !empty($sRow->OVIS_session_data) ? json_decode(base64_decode($sRow->OVIS_session_data),true) : array();
			}
		}
	}
	if(empty($wp_session['session_data']['sSettings']) || is_user_logged_in()){	
		$_oSettings = new settings();
		$aSessionKeys = array('sSettings');		
		addDataToSession($aSessionKeys,$_oSettings->get_settings());
	}
	clearSessionTable();
}
add_action('init', 'start_session', 2);
function addDataToSession($aKeys=false,$data=false){
	if(empty($aKeys) || !is_array($aKeys)){
		return false;
	}
	global $wpdb;
	global $wp_session;	
	$iCountKeys = count($aKeys);	
	$iCountKey = 0;
	$aSessionElementToLookStart = !empty($wp_session['session_data']) ? $wp_session['session_data'] : false;
	$aSessionElementToLookIn = !empty($wp_session['session_data']) ? $wp_session['session_data'] : false;
	foreach($aKeys as $value){		
		$iCountKey++;
		
		if(!is_array($wp_session['session_data'])){
			$wp_session['session_data'] = array();
		}
		
		if($iCountKeys == 1){
			$wp_session['session_data'][$aKeys[0]] = $data;
		} elseif($iCountKeys == 2){
			if(!isset($aSessionElementToLookIn[$aKeys[0]])){			
				$wp_session['session_data'][$aKeys[0]] = array();
			}			
			$wp_session['session_data'][$aKeys[0]][$aKeys[1]] = $data;
		} elseif($iCountKeys == 3){
			if(!isset($aSessionElementToLookIn[$aKeys[0]])){			
				$wp_session['session_data'][$aKeys[0]] = array();
			}			
			if(!isset($aSessionElementToLookIn[$aKeys[0]][$aKeys[1]])){			
				$wp_session['session_data'][$aKeys[0]][$aKeys[1]] = $data;
			}						
			$wp_session['session_data'][$aKeys[0]][$aKeys[1]][$aKeys[2]] = $data;
		} elseif($iCountKeys == 4){
			if(!isset($aSessionElementToLookIn[$aKeys[0]])){			
				$wp_session['session_data'][$aKeys[0]] = array();
			}			
			if(!isset($aSessionElementToLookIn[$aKeys[0]][$aKeys[1]])){			
				$wp_session['session_data'][$aKeys[0]][$aKeys[1]] = $data;
			}			
			if(!isset($aSessionElementToLookIn[$aKeys[0]][$aKeys[1]][$aKeys[2]])){			
				$wp_session['session_data'][$aKeys[0]][$aKeys[1]][$aKeys[2]] = $data;
			}			
			$wp_session['session_data'][$aKeys[0]][$aKeys[1]][$aKeys[2]][$aKeys[3]] = $data;
		} elseif($iCountKeys == 5){
			if(!isset($aSessionElementToLookIn[$aKeys[0]])){			
				$wp_session['session_data'][$aKeys[0]] = array();
			}			
			if(!isset($aSessionElementToLookIn[$aKeys[0]][$aKeys[1]])){			
				$wp_sessionv[$aKeys[0]][$aKeys[1]] = $data;
			}			
			if(!isset($aSessionElementToLookIn[$aKeys[0]][$aKeys[1]][$aKeys[2]])){			
				$wp_session['session_data'][$aKeys[0]][$aKeys[1]][$aKeys[2]] = $data;
			}			
			if(!isset($aSessionElementToLookIn[$aKeys[0]][$aKeys[1]][$aKeys[2]][$aKeys[3]])){			
				$wp_session['session_data'][$aKeys[0]][$aKeys[1]][$aKeys[2]][$aKeys[3]] = $data;
			}	
			$wp_session['session_data'][$aKeys[0]][$aKeys[1]][$aKeys[2]][$aKeys[3]][$aKeys[4]] = $data;			
		}
	}
	$sSessionID = session_id();				
	if(empty($sSessionID)){
		$sSessionID = bin2hex(openssl_random_pseudo_bytes(32));
	}
	$sQuery = "INSERT INTO `".OVIS_DB_PREFIX."ovis_sessions` SET `OVIS_session_key` = '".($sSessionID)."',`OVIS_session_date` = '".(date('Y-m-d H:i:s'))."',`OVIS_session_data` = '".(base64_encode(json_encode($wp_session, JSON_UNESCAPED_SLASHES)))."' ON DUPLICATE KEY UPDATE `OVIS_session_date` = '".(date('Y-m-d H:i:s'))."',`OVIS_session_data` = '".(base64_encode(json_encode($wp_session, JSON_UNESCAPED_SLASHES)))."';";
	if(!$stmt = $wpdb->dbh->prepare($sQuery)) {		
		/*$this->bSettingsError = true; */
	} else {							
		$sResult = $wpdb->dbh->query($sQuery) or trigger_error(mysqli_error($wpdb->dbh), E_USER_ERROR);
	}	
	return;
}
/*
*
* Check Database
*
*/
function check_database() {	
	if(!is_admin()){
		return;
	}
	global $wpdb;
	$tblNameSettings = OVIS_DB_PREFIX . "ovis";	
	/* Create settings table */
	$sqlCreateSettingsTable = "CREATE TABLE IF NOT EXISTS `".$tblNameSettings."` (
		OVIS_id mediumint(9) NOT NULL AUTO_INCREMENT,
		OVIS_authentication varchar(100) NOT NULL DEFAULT '0',
		OVIS_button_bg_color varchar(7) NOT NULL DEFAULT '#DFDFDF',
		OVIS_button_text_color varchar(7) NOT NULL DEFAULT '#333333',
		OVIS_object_bg_color varchar(7) NOT NULL DEFAULT '#DFDFDF',
		OVIS_object_text_color varchar(7) NOT NULL DEFAULT '#333333',		
		OVIS_items_per_page int(3) NOT NULL DEFAULT '12',
		OVIS_items_per_page_no_filter int(3) NOT NULL DEFAULT '12',
		OVIS_items_per_row int(1) NOT NULL DEFAULT '3',		
		OVIS_bg_color varchar(7) NOT NULL DEFAULT '#f6f6f6',
		OVIS_text_color varchar(7) NOT NULL DEFAULT '#333333',
		PRIMARY KEY (OVIS_id)
		) DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci
	";
	$sResult = $wpdb->dbh->query($sqlCreateSettingsTable) or trigger_error(mysqli_error($wpdb->dbh), E_USER_ERROR);
	$tblNameSessions = OVIS_DB_PREFIX . "ovis_sessions";
	$sqlCreateSessionsTableCheck = "CREATE TABLE IF NOT EXISTS `".$tblNameSessions."` (
	OVIS_session_key VARCHAR(100) NOT NULL DEFAULT '0',
	OVIS_session_date DATETIME NULL,
	OVIS_session_data TEXT NULL,
	UNIQUE `sessionKey` (`OVIS_session_key`)
	) DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci";
	$sResult = $wpdb->dbh->query($sqlCreateSessionsTableCheck) or trigger_error(mysqli_error($wpdb->dbh), E_USER_ERROR);	
	$sqlAlterSessionsTableCheck = "ALTER TABLE `".$tblNameSessions."` CHANGE `OVIS_session_data` `OVIS_session_data` LONGTEXT CHARACTER SET latin1 COLLATE latin1_swedish_ci NULL DEFAULT NULL";		$sResult = $wpdb->dbh->query($sqlAlterSessionsTableCheck) or trigger_error(mysqli_error($wpdb->dbh), E_USER_ERROR);		
		$sQuery = "SELECT * FROM ".OVIS_DB_PREFIX."ovis WHERE 1=1 LIMIT 1";
	if(!$stmt = $wpdb->dbh->prepare($sQuery)) {				
		/*$this->bSettingsError = true; */
	} else {							
		$sResult = $wpdb->dbh->query($sQuery) or trigger_error(mysqli_error($wpdb->dbh), E_USER_ERROR);
		if($sResult) {
			$sRow = mysqli_fetch_object($sResult);			
			if(!property_exists($sRow,'OVIS_anchor')){
				$sQueryAdd = "ALTER TABLE `".OVIS_DB_PREFIX."ovis` ADD COLUMN `OVIS_anchor` VARCHAR(50) NOT NULL;";
				if(!$stmt = $wpdb->dbh->prepare($sQueryAdd)) {
					/*$this->bSettingsError = true;	 */
				} else {		
					$sResult = $wpdb->dbh->query($sQueryAdd) or trigger_error(mysqli_error($wpdb->dbh), E_USER_ERROR);
				}
			}
			if(!property_exists($sRow,'OVIS_sessionclean')){
				$sQueryAdd = "ALTER TABLE `".OVIS_DB_PREFIX."ovis` ADD COLUMN `OVIS_sessionclean` DATETIME NULL;";
				if(!$stmt = $wpdb->dbh->prepare($sQueryAdd)) {
					/*$this->bSettingsError = true;	 */
				} else {		
					$sResult = $wpdb->dbh->query($sQueryAdd) or trigger_error(mysqli_error($wpdb->dbh), E_USER_ERROR);
				}			} 
			if(!property_exists($sRow,'OVIS_items_per_page_no_filter')){
				$sQueryAdd = "ALTER TABLE `".OVIS_DB_PREFIX."ovis` ADD COLUMN `OVIS_items_per_page_no_filter` int(3) NOT NULL DEFAULT '12' AFTER OVIS_items_per_page;";				
				if(!$stmt = $wpdb->dbh->prepare($sQueryAdd)) {	
					/*$this->bSettingsError = true; */					
				} else {				
					$sResult = $wpdb->dbh->query($sQueryAdd) or trigger_error(mysqli_error($wpdb->dbh), E_USER_ERROR);
				}						
			}
			if(!property_exists($sRow,'OVIS_custom_css')){
				$sQueryAdd = "ALTER TABLE `".OVIS_DB_PREFIX."ovis` ADD COLUMN `OVIS_custom_css` TEXT NOT NULL;";
				if(!$stmt = $wpdb->dbh->prepare($sQueryAdd)) {	
					/*$this->bSettingsError = true;		 */			
				} else {				
					$sResult = $wpdb->dbh->query($sQueryAdd) or trigger_error(mysqli_error($wpdb->dbh), E_USER_ERROR);
				}						
			}			
			if(!property_exists($sRow,'OVIS_translations')){
				$sQueryAdd = "ALTER TABLE `".OVIS_DB_PREFIX."ovis` ADD COLUMN `OVIS_translations` TEXT NOT NULL;";
				if(!$stmt = $wpdb->dbh->prepare($sQueryAdd)) {	
					/*$this->bSettingsError = true;	 */				
				} else {				
					$sResult = $wpdb->dbh->query($sQueryAdd) or trigger_error(mysqli_error($wpdb->dbh), E_USER_ERROR);
				}						
			}
			if(!property_exists($sRow,'OVIS_texts')){
				$sQueryAdd = "ALTER TABLE `".OVIS_DB_PREFIX."ovis` ADD COLUMN `OVIS_texts` TEXT NOT NULL;";
				if(!$stmt = $wpdb->dbh->prepare($sQueryAdd)) {	
					/*$this->bSettingsError = true;		 */			
				} else {				
					$sResult = $wpdb->dbh->query($sQueryAdd) or trigger_error(mysqli_error($wpdb->dbh), E_USER_ERROR);
				}						
			}				
		}		
	}	
}
add_action('init', 'check_database', 1);
/*
*
* Include necessary scripts and styles for admin section
*
*/
function enqueue_admin_ovis($hook) {
	$pages = array(
		'toplevel_page_ovis-general',
		'ovis_page_ovis-design',
		'ovis_page_ovis-integration',
		'ovis_page_ovis-settings',
		'ovis_page_ovis-appearance',
		'ovis_page_ovis-translation'
	);
	if(!in_array($hook, $pages)) {
        return;
    }
	$versionAssets = OVIS_VERSION;
	wp_enqueue_script('script_jquery-spectrum', plugin_dir_url(__FILE__) . '../assets/js/jquery.spectrum.js', array('jquery'),$versionAssets);	wp_enqueue_script('script_jquery-ui', plugin_dir_url(__FILE__) . '../assets/js/jquery.ui.js', array('jquery'),$versionAssets);
	wp_enqueue_script('script_jquery-ui-widget', plugin_dir_url(__FILE__) . '../assets/js/jquery.ui.widget.js', array('jquery'),$versionAssets);
	wp_enqueue_script('script_jquery-script', plugin_dir_url(__FILE__) . '../assets/js/jquery.scripts.js', array('jquery'),$versionAssets);
	wp_localize_script('script_jquery-script', 'plugin_url', array( 'plugin_url' => plugins_url() ));
    wp_enqueue_style('style_default', plugin_dir_url(__FILE__) . '../assets/css/style-default.css',false,$versionAssets);
	wp_enqueue_style('style_spectrum', plugin_dir_url(__FILE__) . '../assets/css/jquery-spectrum.css',false,$versionAssets); }
add_action('admin_enqueue_scripts', 'enqueue_admin_ovis');
/*
*
* Initialize shortcode OVIS output
*
*/
function display_output_shortcode($atts) {
	/*global $oSettings; */
	global $oOutput;
	global $wp_query;
	global $wp_session;
	$sSettings = $wp_session['session_data']['sSettings'];
	/*
	*
	* Parameters
	*
	* - category
	* - condition
	* - rental
	* - filters	*	*/
	extract(shortcode_atts(array(
		'aanbieders' => 'nee',
		'anchor' => '',
		'beschikbaar' => 'inbegrepen',
		'bouwjaar' => '',
		'brandstof' => '',
        'btwmarge' => 'ja',
		'categorie' => '',
		'conditie' => 'nieuw, occasion',
		'dealer' => '',
		'dealerfooter' => 'ja',
		'deeplink' => '',
		'extrafilters' => 'dicht',
		'filters' => 'ja',
		'kalender' => 'show',
		'keyword' => '',
		'layout' => '',
		'merk' => '',
		'modeljaar' => '',
		'module' => 'ovis',
		'perrij' => '',
		'prijzen' => '',
		'scrollonload' => 'nee',
        'shopknop' => 'nee',
		'socialmedia' => 'ja',
		'sorteren' => 'merk oplopend',
		'specificaties' => 'dicht',
		'status' => '',
		'subcategorie' => '',
		'taal' => 'nl',
		'toonnaw' => 'ja',
		'verbergfilters' => '',
		'verhuur' => 'nee',
		'verkocht' => 'ja',
		'inruilfotos' => 'optioneel',
		'calltoaction' => '',
		'volgordespecificaties' => ''
	), $atts));
	$aAllowedCategories = explode(',',str_replace(' ', '', OVIS_ALLOWED_CATEGORIES));	
		if($module == 'boten'){
		$aAllowedCategories = explode(',',str_replace(' ', '', OVIS_ALLOWED_BOATCATEGORIES));	
	}
	if(empty($categorie)){
		$categorie = 'caravan, kampeerauto, stacaravan, vouwwagen, aanhangwagen';		
		if($module == 'boten'){
			$categorie = 'boot, motor, boottrailer';
		}
	}
	$aSetCategories = explode(',',str_replace(' ', '', $categorie));	
	foreach($aSetCategories as $setCategoryKey => $setCategory){
		if(!in_array($setCategory,$aAllowedCategories)){
			unset($aSetCategories[$setCategoryKey]);
		}
	}		
	$categorie = implode(',',$aSetCategories);
	/* Category */
	if($module == 'boten'){		
		$replaceItems 	= ["boot", "motor", "boottrailer"];
		$replaceWith 	= ["boat", "engine", "boattrailer"];
		$category 		= str_replace($replaceItems, $replaceWith, $categorie);
	} else {	
		$replaceItems 	= ["kampeerauto", "stacaravan", "vouwwagen", "aanhangwagen", "caravan"];
		$replaceWith 	= ["camper", "mobilehome", "tenttrailer", "trailer", "caravan"];
		$category 		= str_replace($replaceItems, $replaceWith, $categorie);
	}
	$checkCategories = explode(',',strtolower($category));		
	$invalidCategory = false;
	foreach($checkCategories as $checkCategorie){			
		if(!in_array($checkCategorie,$replaceWith)){
			$invalidCategory = true;
		}
	}
	if(!empty($invalidCategory)){
		$category  = 'invalid';
	}	
	/* 	 * Subcategory 	 */
	$subcategory = !empty($subcategorie) ? $subcategorie : false;	
	/* 	 * Direct beschikbaar 	 */
	switch($beschikbaar){
		case 'isoleren':
			$beschikbaarParsed = 'only';
			break;
		case 'inbegrepen':
			$beschikbaarParsed = 'include';
			break;
		default:
			$beschikbaarParsed = 'exclude';	
			break;
	}	
	$available = $beschikbaarParsed;
    /* 	 * Keyword 	 */
	$keyword = !empty($keyword) ? $keyword : false;		/* 	 * layout 	 */
	$layout = !empty($layout) && $layout == 'blokken' ? 'grid' : (!empty($layout) && $layout == 'lijst' ? 'list' : false);
	/* 	* Dealer 	*/
	$dealer = !empty($dealer) ? $dealer : false;
	/* 	 * Condition 	 */
	$condition 		= 'all';
	$conditionSet 	= explode(',',str_replace(' ', '', $conditie));
	if(in_array('nieuw', $conditionSet) && !in_array('occasion', $conditionSet)) {
		$condition = 'new';
	} else if(!in_array('nieuw', $conditionSet) && in_array('occasion', $conditionSet)) {
		$condition = 'occasion';	}		/* 	 * Per rij 	 */
	if(!empty($perrij)){
		if((int) $perrij < 2){
			$perrij = (int) '2';				
		} elseif((int) $perrij > 5){
			$perrij = (int) '5';				
		} else {
			$perrij = (INT) $perrij;
		}
	} 
	/* 	 * Deeplink 	 */
	$deeplink = !empty($deeplink) ? $deeplink : false;
    /* 	 * btw marge 	 */
	$showBtwMarge = strtolower($btwmarge) == 'nee' ? false : true;
	/* 	 * Show sold 	 */
	$showSold = strtolower($verkocht) == 'ja' ? true : (strtolower($verkocht) == 'einde' ? 'last' : false);
	/* 	* Rental 	*/
	$rental = strtolower($verhuur) == 'ja' ? true : false;
	/* 	 * Scroll on load 	 */
	$scrollonload = strtolower($scrollonload) == 'ja' ? true : false;
    /* 	 * shop 	 */		
	$shop = strtolower($shopknop) == 'ja' ? true : false;	/* 	 * Prijzen instellen 	 */
	$prijzen = !empty($prijzen) ? strtolower($prijzen) : false;
	/* 	* Taal instellen 	*/
	$taal = !empty($taal) ? strtolower($taal) : false;	 	 if(!empty($taal)){		$aFilteredTaal = array();
		$aAllowedLanguages = explode(',',str_replace(' ', '', OVIS_ALLOWED_LANGUAGES));
		$aSetLanguage = explode(',',str_replace(' ', '', $taal));
		foreach($aSetLanguage as $value){
			if(in_array($value,$aAllowedLanguages)){
				$aFilteredTaal[] = $value;
			}
		}
		if(empty($aFilteredTaal)){
			$aFilteredTaal[] = 'nl';
		}		
		$taal = $aFilteredTaal;
	}
	/* 	* anchor 	*/
	$anchor = !empty($anchor) ? $anchor : false;
	/* 	 * Filter users 	 */
	$filterusers = strtolower($aanbieders) == 'ja' ? true : false;
	/* 	 * Filter bouwjaar 	 */
	$bouwjaar = !empty($bouwjaar) ? $bouwjaar : false;
	if(!empty($bouwjaar)){
		$aBouwjaar = explode('-',$bouwjaar);
		if(is_array($aBouwjaar) && count($aBouwjaar) == 2){
			if($aBouwjaar[0] <= $aBouwjaar[1]){
				$bouwjaar = new stdClass();			
				$bouwjaar->from = $aBouwjaar[0];				
				$bouwjaar->till = $aBouwjaar[1];				
			} else {				
				$bouwjaar = false;			
			}			
		} else {
			$bouwjaar = false;			
		}
	}
	/* 	 * Filter modeljaar 	 */
	$modeljaar = !empty($modeljaar) ? $modeljaar : false;
	if(!empty($modeljaar)){
		$aModeljaar = explode('-',$modeljaar);
		if(is_array($aModeljaar) && count($aModeljaar) == 2){
			if($aModeljaar[0] <= $aModeljaar[1]){
				$modeljaar = new stdClass();			
				$modeljaar->from = $aModeljaar[0];				
				$modeljaar->till = $aModeljaar[1];				
			} else {				
				$modeljaar = false;			
			}			
		} else {
			$modeljaar = false;			
		}
	}	
	/* 	 * Brandstof 	 */
	$brandstof = !empty($brandstof) ? $brandstof : false;
	/* 	 * Status 	 */
	$status = !empty($status) ? $status : false;
	/* 	 * Brands 	 */
	$brands = !empty($merk) ? $merk : false;
	/* 	 * Filters 	 */
	$searchFilters = strtolower($filters) == 'nee' ? false : ( strtolower($filters) == 'open' ? 'expanded' : true);	
	/* 	 * Kalender 	 */
	$showCalendar = strtolower($kalender) == 'nee' ? false : true;	
	/* 	 * Sorteren 	 */	
	$aSortParameters = explode(' ', $sorteren);
	/* 	 * Inruilfotos 	 */	
	$inruilfotos = $inruilfotos == 'optioneel' ? 'optional' : ($inruilfotos == 'verplicht' ? 'required' : ($inruilfotos == 'uitgeschakeld' ? 'disabled' : 'optional'));
	/* 	 * CallToAction 	 */		
	$calltoaction = !empty($calltoaction) ? $calltoaction : false;	
	/* 
	 * Set Inruilfotos
	 */	
	$oOutput->setCallToAction($calltoaction);	
	/* 
	 * Set Inruilfotos
	 */	
	$oOutput->setTradeInPictures($inruilfotos);
	/* 
	 * Set layout new or occasion
	 */	
	$oOutput->setLayout($layout);
	/* 
	 * Set condition new or occasion
	 */	
	$sShowConditionNewOrOccasion = (!empty($condition) ? $condition : 'all');
	$oOutput->showConditionNewOrOccasion($sShowConditionNewOrOccasion);
	/* 
	 * Show 'more specifications' open or closed
	 */	
	$sMoreSpecifications = (!empty($specificaties) && $specificaties == 'open' ? 'open' : 'closed');
	$oOutput->showMoreSpecifications($sMoreSpecifications);
	/* 
	 * Show 'extra filters' open or closed
	 */	
	$sShowExtraFilters = (!empty($extrafilters) && $extrafilters == 'open' ? 'open' : 'closed');
	$oOutput->showExtraFilters($sShowExtraFilters);
	/* 
	 * Show 'contact address' on detailpage yes or no
	 */		 
	$sShowContactAddress = (!empty($toonnaw) && $toonnaw == 'ja' ? 'yes' : 'no');
	$oOutput->showContactAddress($sShowContactAddress);	
	/* 
	 * Show 'contact social links' on detailpage yes or no
	 */	
	$sShowSocials = (!empty($socialmedia) && $socialmedia == 'ja' ? 'yes' : 'no');
	$oOutput->showSocials($sShowSocials);	
	/* 
	 * Show 'dealer footer' on detailpage yes or no
	 */	
	$sShowDealerFooter = (!empty($dealerfooter) && $dealerfooter == 'ja' ? 'yes' : 'no');	$oOutput->showDealerFooter($sShowDealerFooter);
	/* 
	 * Specification order
	 */		$aSpecificationsOrder = [];
	$aSpecificationsOrderRaw = (!empty($volgordespecificaties) ? array_map('trim', explode(',', $volgordespecificaties)) : []);
	$aSpecificationsAllowed = ['bouwjaar', 'slaapplaatsen', 'kilometerstand', 'transmissie', 'gordels', 'gewicht', 'lengte', 'laadvermogen', 'breedte', 'subcategorie', 'totalelengte', 'snelvarend', 'vermogen','romp'];
	if(!empty($aSpecificationsOrderRaw)) {
		foreach($aSpecificationsOrderRaw as $sSpecificationRaw) {
			if(in_array($sSpecificationRaw, $aSpecificationsAllowed)) {
				$aSpecificationsOrder[] = $sSpecificationRaw;
			} 
		}	}
	$oOutput->specificationsOrder($aSpecificationsOrder);
	/* 
	 * Hide filters on frontpage
	 */	
	$aHideFilters = (!empty($verbergfilters) ? array_map('trim', explode(',', $verbergfilters)) : []);
	$oOutput->hideFilters($aHideFilters);
	/*
	 * Sorting
	 */
	$sSortField = 'brand';
	$sSortOrder = 'asc';	
	if(!empty($aSortParameters[1])){
		switch($aSortParameters[1]){
			case 'oplopend':
				$sSortOrder = 'asc';
				break;
			case 'aflopend':
				$sSortOrder = 'desc';
				break;			
		}	
	}
	if(!empty($aSortParameters[0])){
		switch($aSortParameters[0]){
			case 'merk':
				if($sSortOrder == 'asc'){					
					$sSortField = 'brand_up';
				} else {
					$sSortField = 'brand_down';
				}
				break;
			case 'prijs':
				if($sSortOrder == 'asc'){					
					$sSortField = 'price_up';
				} else {
					$sSortField = 'price_down';
				}
				break;
			case 'bouwjaar':
				if($sSortOrder == 'asc'){					
					$sSortField = 'constructionYear_up';
				} else {
					$sSortField = 'constructionYear_down';
				}
				break;
			case 'gewicht':
				if($sSortOrder == 'asc'){					
					$sSortField = 'maxWeight_up';
				} else {
					$sSortField = 'maxWeight_down';
				}
				break;
			case 'slaapplaatsen':
				if($sSortOrder == 'asc'){					
					$sSortField = 'sleepingPlaces_up';
				} else {
					$sSortField = 'sleepingPlaces_down';
				}
				break;
			case 'categorie':				
				$sSortField = 'category';
				break;
			case 'aanmaakdatum':
				$sSortField = 'creationDate';				
				break;
			case 'willekeurig':				
				$sSortField = 'random';
				break;
		}	
	}	
	$searchSorting = new stdclass();
	$searchSorting->field = $sSortField;	$searchSorting->order = $sSortOrder;	
	/*
	*
	* CSS/scripts includes
	*
	*/	
	$versionAssets = OVIS_VERSION;
	wp_enqueue_script('script_jquery-dateTimePicker', plugin_dir_url(__FILE__) . '../assets/js/dateTimePicker.min.js', array('jquery'),$versionAssets);
	wp_enqueue_script('script_jquery-ui', plugin_dir_url(__FILE__) . '../assets/js/jquery.ui.js', array('jquery'),$versionAssets);
	wp_enqueue_script('script_jquery-spectrum', plugin_dir_url(__FILE__) . '../assets/js/jquery.spectrum.js', array('jquery'),$versionAssets);
	wp_enqueue_script('script_jquery-fotorama', plugin_dir_url(__FILE__) . '../assets/js/jquery.fotorama.js', array('jquery'),$versionAssets);	
	wp_enqueue_script('script_jquery-multiselect', plugin_dir_url(__FILE__) . '../assets/js/jquery.multiselect.js', array('jquery'),$versionAssets);
	wp_enqueue_script('script_jquery-script', plugin_dir_url(__FILE__) . '../assets/js/jquery.scripts.js', array('jquery'),$versionAssets);
	wp_enqueue_script('script_uppy-bundle', plugin_dir_url(__FILE__) . '../assets/js/uppy-bundle.js', array('jquery'),$versionAssets);
	wp_localize_script('script_jquery-script', 'plugin_url', array( 'plugin_url' => plugins_url() ));	
	wp_localize_script('script_jquery-script', 'my_ajax_object', array( 'ajax_url' => admin_url('admin-ajax.php')));
	$oOutput->aLanguages = $taal;	
	$oOutput->sShowPrices = $prijzen;
	/* 
	 * Display output 
	 */	 
	$oOutput->setCategory($category);
	$oOutput->setSubcategory($subcategory);
	$oOutput->setCondition($condition);
	$oOutput->setRealm($module);
	$oOutput->setRental($rental);
	$oOutput->setScrollonload($scrollonload);
	$oOutput->setSearchFilters($searchFilters);
	$oOutput->setShowCalendar($showCalendar);
	$oOutput->setSearchSorting($searchSorting);
	$oOutput->setShowSold($showSold);
	$oOutput->setBrands($brands);
	$oOutput->setFilterusers($filterusers);
	$oOutput->setDeeplink($deeplink);
	$oOutput->setAnchor($anchor);
	$oOutput->setBouwjaar($bouwjaar);
	$oOutput->setModeljaar($modeljaar);
	$oOutput->setDealer($dealer);
	$oOutput->setPerrij($perrij);
	$oOutput->setShop($shop);
	$oOutput->setAvailable($available);
	$oOutput->setKeyword($keyword);
	$oOutput->setShowBtwMarge($showBtwMarge);
	$oOutput->setBrandstof($brandstof);
	$oOutput->setStatus($status);
	return $oOutput->build_output($wp_query);
}
add_shortcode('ovis-voorraad', 'display_output_shortcode');
function load_ovis_plugin_css($versionAssets) {	
	global $wp_session;	global $wp_query;
	
	$ovisUrlObjectId = get_query_var('ovis_object_id');
	
	wp_enqueue_style('ovis-style-jquery-ui', plugin_dir_url(__FILE__) . '../assets/css/jquery-ui.css',true,$versionAssets ); 	wp_enqueue_style('ovis-style-output', plugin_dir_url(__FILE__) . '../assets/css/style-output.css',true,$versionAssets ); 
	if(!empty($ovisUrlObjectId)){		wp_enqueue_style('ovis-style-print', plugin_dir_url(__FILE__) . '../assets/css/style-print.css',true,$versionAssets,'print'); 			}
	wp_enqueue_style('ovis-style-fotorama', plugin_dir_url(__FILE__) . '../assets/css/jquery-fotorama.css',true,$versionAssets); 	wp_enqueue_style('ovis-style-multiselect', plugin_dir_url(__FILE__) . '../assets/css/jquery.multiselect.css',true,$versionAssets); 	wp_enqueue_style('ovis-style-font-awesome', plugin_dir_url(__FILE__) . '../assets/css/all.css',true,$versionAssets); 	wp_enqueue_style('ovis-style-dateTimePicker', plugin_dir_url(__FILE__) . '../assets/css/dateTimePicker.css',true,$versionAssets);	wp_enqueue_style('ovis-style-uppy', plugin_dir_url(__FILE__) . '../assets/css/uppy.min.css',false,$versionAssets); 
	$button_bg_color 	= $wp_session['session_data']['sSettings']['settings']['button_bg_color'];
	$button_text_color 	= $wp_session['session_data']['sSettings']['settings']['button_text_color'];	$object_bg_color 	= $wp_session['session_data']['sSettings']['settings']['object_bg_color'];
	$object_text_color 	= $wp_session['session_data']['sSettings']['settings']['object_text_color'];
	$bg_color 			= $wp_session['session_data']['sSettings']['settings']['bg_color'];
	$text_color 		= $wp_session['session_data']['sSettings']['settings']['text_color'];	
	$items_per_row 		= $wp_session['session_data']['sSettings']['settings']['items_per_row'];
	$custom_css_db		= $wp_session['session_data']['sSettings']['settings']['custom_css'];
		$custom_css = 'div.ovis-objecten li.object {
		background: '.$bg_color.' !important;
	}
	a.ovis-go-back {		color: '.$text_color.' !important;	}
	.ovis-download-attachment {
		background-color:'.$button_bg_color.' !important; 
		border-color:'.$button_bg_color.' !important; 
		color: '.$button_text_color.' !important;
	}
	div.ovis-detail div.ovis-detail-section,
	div.ovis-detail div.ovis-detail-section ul li,
	div.ovis-detail div.ovis-detail-section p,
	section.content .vlak.page p,
	div.ovis-detail div.ovis-detail-section.ovis-user div.ovis-user-block {
		color: '.$text_color.' !important;
	}
	div.ovis-pager .pager-button.text.active { 
		background-color:'.$button_bg_color.' !important; 
		border-color:'.$button_bg_color.' !important; 
		color: '.$button_text_color.' !important;
	}
	div.ovis-pager .pager-button:hover {
		background: '.adjustBrightness($button_bg_color, 20).' !important;
		border-color: '.adjustBrightness($button_bg_color, 20).' !important;
	}
	div.ovis-filters {
		background: '.$bg_color.' !important;
		border-color: '.adjustBrightness($bg_color, -20).' !important;
	}
	div.ovis-filters h3 {
		color: '.$text_color.' !important;			
	}
	form.ovis-search {
		background: '.$bg_color.' !important;
		border-color: '.adjustBrightness($bg_color, -20).' !important;
	}
	div.ovis-pager .pager-button {
		background: '.$bg_color.' !important;
	}
	form.ovis-search div.contain-filters,
	form.ovis-search div.contain-filters.hidden {
		border-color: '.adjustBrightness($bg_color, -20).';
		color: '.$text_color.' !important;
	}
	form.ovis-search div.contain-filter label,
	form.ovis-search div.contain-buttons div.ovis-found p,
	form.ovis-search div div.moreFilters {
		color: '.$text_color.' !important;
	}
	form.ovis-search div.contain-filters.main div.moreFilters:hover,
	form.ovis-search div.contain-filters.main div.moreFilters:hover i {
		color: '.adjustBrightness($text_color, -30).' !important;
	}		
	form.ovis-search input[type="submit"] {
		background: '.$button_bg_color.' !important;
		color: '.$button_text_color.' !important;
	}
	form.ovis-search input[type="submit"]:hover {
		background: '.adjustBrightness($button_bg_color, 20).' !important;
	}
	div.ovis-objecten li.object span.ovis-object-title,
	div.ovis-objecten li.object a,
	div.ovis-objecten li.object span.ovis-sub-title {
		color: '.$text_color.' !important;
	}
	#ovis-container.list:not(.minimal) div.ovis-objecten li.object div.ovis-row.price {
		/*color: '.$text_color.' !important;*/
	}
	div.ovis-objecten li.object:hover { 
		border-color: '.$object_bg_color.' !important;
	}
	div.ovis-objecten li.object div.ovis-inruilvoorstel {		border-color: '.$object_bg_color.' !important;	}
	div.ovis-objecten li.object div.ovis-row {
		border-color: '.adjustBrightness($bg_color, -20).' !important;
	}
	div.ovis-objecten li.object div.ovis-row.price {
		background: '.$object_bg_color.';
		border: 1px solid '.$object_bg_color.';
		color: '.$object_text_color.';	}
	div.ovis-objecten li.object a div.ovis-open-inruilform {
		background: '.$object_bg_color.' !important;
		color: '.$object_text_color.' !important;
	}
	div.ovis-objecten li.object a div.ovis-open-inruilform i {
		color: '.$object_text_color.' !important;
	}				
	#ovis-container.list:not(.minimal) li.object a div.ovis-open-verhuurform .ovis-open-verhuurform-btn {
		background: '.$object_bg_color.' !important;
		color: '.$object_text_color.' !important;
	}
	#ovis-container.list:not(.minimal) li.object a div.ovis-open-verhuurform .ovis-open-verhuurform-btn i {
		color: '.$object_text_color.' !important;	}				
	div.ovis-detail div.ovis-detail-top-links a:hover {
		border-color: '.$button_bg_color.' !important;
	}
	';		if(strtolower($button_bg_color) != '#dfdfdf'){		$custom_css .= 'div.ovis-contactline {			color: '.$button_bg_color.' !important;		}';	}	if(strtolower($button_bg_color) != '#dfdfdf'){
		$custom_css .= '
		div.ovis-detail div.ovis-contain div.ovis-specifications div.more-specs {
			color: '.$button_bg_color.' !important;
		}
			
		div.ovis-contactline a {
			color: '.$button_bg_color.' !important;
		}';	}
	if(strtolower($button_bg_color) != '#dfdfdf'){					$custom_css .= '.ovis-ctabutton, .ovis-ctabutton a {
			color: '.$button_bg_color.' !important;
		}';				}		
	$custom_css .= '.ovis-ctabutton.ovis-shop-knop {
		background: '.$button_bg_color.' !important;
		color: '.$button_text_color.' !important;
	}
	.ovis-cta-choice.active {
		background: '.$button_bg_color.' !important;
		color: '.$button_text_color.' !important;
	}
	.ovis-action-form .sendbutton {
		background: '.$button_bg_color.' !important;
		color: '.$button_text_color.' !important;
	}
	div.ovis-detail div.ovis-detail-top-links div.social-buttons-c a.social-buttons {
		background: '.$button_bg_color.';
		color: '.$button_text_color.' !important;
	}
	div.ovis-detail div.ovis-detail-top-links div.social-buttons-c a.social-buttons i {
		color: '.$button_text_color.' !important;
	}
	div.ovis-detail div.ovis-detail-top-links div.social-buttons-c a.social-buttons:hover {
		background: '.adjustBrightness($button_bg_color, 20).' !important;
	}
	.fotorama__thumb-border {
		border-color: '.$button_bg_color.' !important;
	}';
	if(strtolower($button_bg_color) != '#dfdfdf'){						$custom_css .= 'div.ovis-detail div.ovis-detail-section h3 i {
			color: '.$button_bg_color.' !important;
		}';	}
	$custom_css .= 'div.ovis-objecten li.object .imgContainer div.label,
	div.ovis-detail .ovis-detail-title div.label {
		background: '.$button_bg_color.' !important;		color: '.$button_text_color.' !important;
	}
	form.ovis-search div.contain-buttons div.ovis-sort .ovis-order span:hover {
		color: '.$button_text_color.' !important;
	}	
	form.ovis-search div.contain-buttons div.ovis-sort .ovis-order span.active {
		color: '.$button_text_color.' !important;
	}	
	div.ovis-detail div.ovis-detail-section.ovis-media h3 span.button.active {
		background: '.$button_bg_color.' !important;
		border-color: '.$button_bg_color.' !important;
		color: '.$button_text_color.' !important;
	}
	div.ovis-detail div.ovis-detail-section .do-verhuur {
		background: '.$button_bg_color.' !important;
		color: '.$button_text_color.' !important;
	}
	.ui-state-active, .ui-widget-content .ui-state-active, .ui-widget-header .ui-state-active, a.ui-button:active, .ui-button:active, .ui-button.ui-state-active:hover, a.ui-state-default.ui-state-active:hover, a.ui-state-default.ui-state-highlight.ui-state-active, a.ui-state-default.ui-state-highlight.ui-state-active:hover {
		background: '.$button_bg_color.' !important;				
		color: '.$button_text_color.' !important;
	}';	if(strtolower($button_bg_color) != '#dfdfdf'){				$custom_css .= '
		div.ovis-open-inruilform i { color: '.$button_bg_color.' !important; }
		div.ovis-open-inruilform i a { color: '.$button_bg_color.' !important; }
		div.ovis-open-verhuurform i { color: '.$button_bg_color.' !important; }
		div.ovis-open-verhuurform i a { color: '.$button_bg_color.' !important; }
		div.ovis-open-contactform i { color: '.$button_bg_color.' !important; }
		div.ovis-open-contactform i a { color: '.$button_bg_color.' !important; }
		div.ovis-phonenumber i { color: '.$button_bg_color.' !important; }
		div.ovis-phonenumber i a { color: '.$button_bg_color.' !important; }
		div.ovis-show-usercontent i { color: '.$button_bg_color.' !important; }
		div.ovis-show-usercontent i a { color: '.$button_bg_color.' !important; }		';			}			$custom_css .= 'div.ovis-objecten li.object div.ovis-row.price div strong {
		color: '.$object_text_color.';
	}

	div.ovis-objecten li.object div.ovis-row .priceTo a {
		color:#'.$button_text_color.';
	}	
	div.invalid-filter-message {
		background-color: '.$button_bg_color.' !important;
		color: '.$button_text_color.' !important;
		margin-top:10px;
		padding:10px; 
		box-sizing:border-box;
		font-size:13px !important;
		-webkit-border-radius: 3px;
		border-radius: 3px;
	}
	';
	if(isset($custom_css_db) && !empty($custom_css_db)){
		$custom_css .= stripslashes($custom_css_db);
	}
	wp_add_inline_style('ovis-style-output', $custom_css);}
add_action('wp_enqueue_scripts', 'load_ovis_plugin_css');
/*
*
* Adjust color
*
*/
function adjustBrightness($hex, $steps) {
    $steps = max(-255, min(255, $steps));
	$hex = str_replace('#', '', $hex);	
    if(strlen($hex) == 3) {
        $hex = str_repeat(substr($hex,0,1), 2).str_repeat(substr($hex,1,1), 2).str_repeat(substr($hex,2,1), 2);
    }
    $color_parts = str_split($hex, 2);
    $newHex = '#';
    foreach ($color_parts as $color) {
        $color   = hexdec($color); 
        $color   = max(0,min(255,$color + $steps));         $newHex .= str_pad(dechex($color), 2, '0', STR_PAD_LEFT);    }
    return $newHex;
}
/*
*
* mySQL error notice
*
*/

function mysqli_query_error_notice() {
	$sHTML = '<section class="ovis-main">
		<article>
			<div class="content">
				<h2 class="ovis-subtitle">Er is een fout opgetreden</h2>
				<p>Neem contact op met de website beheerder.</p>
			</div>
		</article>
	</section>';
	return $sHTML; 
} 
function show_morefilters_javascript() {
	echo '<script type="text/javascript" >
		jQuery(document).ready(function($) {
			var setFilter;			var moreFilters 	= jQuery(\'form.ovis-search div div.moreFilters\');			var moreFiltersIcon	= jQuery(\'form.ovis-search div div.moreFilters i.fa\');			var moreFiltersCont = jQuery(\'form.ovis-search div.contain-filters.filtershidden\');
			jQuery(moreFilters).click(function() { 			
				var ovisMoreFiltersUniqueID = moreFilters.data(\'uniqueid\');
				if(moreFiltersCont.data(\'morefilters\') === 1) {
					jQuery(moreFiltersCont).slideUp(300);
					jQuery(moreFiltersCont).data(\'morefilters\', 0);
					jQuery(moreFiltersIcon).removeClass(\'fa-minus\').addClass(\'fa-plus\');
					setFilter = 0;					
				} else {
					jQuery(moreFiltersCont).slideDown(300);
					jQuery(moreFiltersCont).data(\'morefilters\', 1);
					jQuery(moreFiltersIcon).removeClass(\'fa-plus\').addClass(\'fa-minus\');
					setFilter = 1;
				}				
				var data = {
					\'action\': \'user_content\',
					\'form_action\': \'morefilters\',
					\'ovis-uniqueid\': ovisMoreFiltersUniqueID,
					\'morefilters\': setFilter
				};
				jQuery.post(my_ajax_object.ajax_url, data, function(response) {		
				});	
			});
		});
	</script>';
}
add_action( 'wp_footer', 'show_morefilters_javascript' );
function show_usercontent_javascript() {	
	echo '<script type="text/javascript" >
		jQuery(document).ready(function($) {
			jQuery.showUserContent = function(ovisUniqueID,ovisUserID,ovisUserName,ovisForwardUrl) {			
				var data = {
					\'action\': \'user_content\',
					\'form_action\': \'usercontent\',
					\'ovis-uniqueid\': ovisUniqueID,
					\'ovis-userid\': ovisUserID,
					\'ovis-username\': ovisUserName
				};
				jQuery.post(my_ajax_object.ajax_url, data, function(response) {
					window.location.href = ovisForwardUrl;					
				});		
			}
		});
	</script>';
}
add_action( 'wp_footer', 'show_usercontent_javascript' );
function create_new_captcha_javascript() {
	echo '<script type="text/javascript" >
		jQuery.createNewCalendar = function(ovisObjectID,ovisUserID){
			var responedata = {
					\'result\': \'succes\',
					\'captcha\': \'hidden\'
			};					
			jQuery.GetBlockedDays(ovisObjectID,ovisUserID,\'calendar\');
		}
		jQuery(document).ready(function($) {						
			jQuery.createNewCaptcha = function(ovisObjectID,ovisUserID,typofform,detailPage,doScroll=true,subject=\'mail\'){											
				var responedata = {
					\'result\': \'succes\',
					\'captcha\': \'hidden\'
				};					
				if(typofform == \'contactform\'){
					jQuery.showOvisContactformHTML(ovisObjectID,ovisUserID,responedata,detailPage,doScroll,subject);
				} else if(typofform == \'inruilform\'){	
					jQuery.showOvisInruilvoorstelHTML(ovisObjectID,ovisUserID,responedata,detailPage,doScroll);
				} else if(typofform == \'verhuurform\'){	
					jQuery.GetBlockedDays(ovisObjectID,ovisUserID,responedata,detailPage,doScroll);
				}							
			}
		});
	</script>';
}
add_action( 'wp_footer', 'create_new_captcha_javascript' );
function send_contact_javascript() {
	echo '<script type="text/javascript" >
		jQuery(document).ready(function($) {
			jQuery.sendOvisContact = function(ovisObjectID) {
				if(jQuery(\'#ovis-aanvragen-\'+ovisObjectID).hasClass(\'processing\')){
					return;
				}			
				jQuery(\'#ovis-aanvragen-\'+ovisObjectID).html(\'in verwerking\').addClass(\'processing\');
				if(jQuery(\'#ovis-contactform-\'+ovisObjectID).length){	
					var data = jQuery(\'#ovis-contactform-\'+ovisObjectID).serialize() + \'&action=send_contact\';
					jQuery.post(my_ajax_object.ajax_url, data, function(response) {
						if(response.status === \'succes\') {
							jQuery(\'#ovis-send-response\').removeClass(\'ovis-error\').addClass(\'ovis-succes\').html(txtOVISBerichtVerzonden);
							if(response.item != \'\') {
								jQuery(\'#ovis-contactform-\'+response.item).remove();
								jQuery(\'#ovis-aanvragen-\'+response.item).remove();
							}
							window.dataLayer = window.dataLayer || [];                                               
							window.dataLayer.push({
								\'event\':\'formContactSubmit\',
								\'contactType\':\'ContactForm\',
							});
							var scollElement = jQuery(\'#ovis-container\').offset();
							var scollElementTop = scollElement.top;
							var overlayItem = jQuery(\'#ovis-action-form\');							
							jQuery(\'html, body\').animate({
								scrollTop: (overlayItem.offset().top) - scollElementTop
							}, 500);
							if(window.dataLayer) {
								var dataLayer = dataLayer || [];  
								dataLayer.push({ 
									\'event\': \'formContactSubmit\'
								}); 															}							
							return;							
						} else {							jQuery(\'#ovis-aanvragen-\'+ovisObjectID).html(\'Versturen\').removeClass(\'processing\');							jQuery(\'.ovis-invalid\').removeClass(\'ovis-invalid\');					
							if(response.errors.captcha){
								jQuery(\'#ovis-send-response\').removeClass(\'ovis-succes\').addClass(\'ovis-error\').html(txtOVISFoutVerzenden);
								jQuery(\'#ovis-contact-name\').val(\'\');
								jQuery(\'#ovis-contact-phone\').val(\'\');
								jQuery(\'#ovis-contact-sender\').val(\'\');
								jQuery(\'#ovis-contact-contactperson\').val(\'\');
								jQuery(\'#ovis-contact-message\').val(\'\');
							} else {							
								jQuery(\'#ovis-send-response\').removeClass(\'ovis-succes\').addClass(\'ovis-error\').html(txtOVISFoutief);
								if(response.errors.subject){
									jQuery(\'#ovis-contact-subject\').addClass(\'ovis-invalid\');
								}
								if(response.errors.date){
									jQuery(\'#ovis-contact-date\').addClass(\'ovis-invalid\');
								}	
								if(response.errors.time){
									jQuery(\'#ovis-contact-time\').addClass(\'ovis-invalid\');
								}
								if(response.errors.name){
									jQuery(\'#ovis-contact-name\').addClass(\'ovis-invalid\');
								}
								if(response.errors.sender){
									jQuery(\'#ovis-contact-contactperson\').addClass(\'ovis-invalid\');
								}
								if(response.errors.phone){
									jQuery(\'#ovis-contact-phone\').addClass(\'ovis-invalid\');
								}								
								if(response.errors.message){
									jQuery(\'#ovis-contact-message\').addClass(\'ovis-invalid\');
								}							}
							return;							
						}
						jQuery(\'#ovis-aanvragen-\'+ovisObjectID).html(\'Versturen\').removeClass(\'processing\');						jQuery(\'#ovis-send-response\').removeClass(\'ovis-succes\').addClass(\'ovis-error\').html(txtOVISFoutVerzenden);
						return;
					});				
				}
				return false;
			};
		});
	</script>';
}
add_action( 'wp_footer', 'send_contact_javascript' );
function send_inruil_javascript() {
	echo '<script type="text/javascript" >
		jQuery(document).ready(function($) {
			jQuery.sendOvisInruilvoorstel = function(ovisObjectID) {
				if(jQuery(\'#ovis-aanvragen-\'+ovisObjectID).hasClass(\'processing\')){
					return;
				}
				if ( typeof uppy !== \'undefined\') {
					jQuery(\'#ovis-aanvragen-\'+ovisObjectID).html(\'verwerking\').addClass(\'processing\');			
					uppy.upload().then((result) => {
						if ( typeof result.successful !== \'undefined\') {							
							jQuery.each(result.successful,function(i,obj){
								jQuery(\'#inruil-images-container\').append(\'<input type="hidden" name="ovis-contact-inruil-images[]" id="\'+ obj.response.uploadURL +\'" value="\'+ obj.response.body.filename +\'" />\');
							});
							jQuery.sendOvisInruilvoorstelData(ovisObjectID);							
						}
					});
				} else {
					jQuery(\'#ovis-aanvragen-\'+ovisObjectID).html(\'verwerking\').addClass(\'processing\');			
					jQuery.sendOvisInruilvoorstelData(ovisObjectID);				
				}
				return;
			};
			jQuery.sendOvisInruilvoorstelData = function(ovisObjectID) {
				if(jQuery(\'#ovis-contactform-\'+ovisObjectID).length){
					var data = jQuery(\'#ovis-contactform-\'+ovisObjectID).serialize() + \'&action=send_inruil\';					
					jQuery.post(my_ajax_object.ajax_url, data, function(response) {
						if(response.status === \'succes\') {
							jQuery(\'#ovis-send-response\').removeClass(\'ovis-error\').addClass(\'ovis-succes\').html(txtOVISAanvraagVerzonden);
														if(response.item != \'\') {
								jQuery(\'#ovis-contactform-\'+response.item).remove();
								jQuery(\'#ovis-aanvragen-\'+response.item).remove();
							}
							window.dataLayer = window.dataLayer || [];                                               
							window.dataLayer.push({
								\'event\':\'formContactSubmit\',
								\'contactType\':\'InruilvoorstelForm\',
							});
							var scollElement = jQuery(\'#ovis-container\').offset();
							var scollElementTop = scollElement.top;
							var overlayItem = jQuery(\'#ovis-action-form\');
							jQuery(\'html, body\').animate({
								scrollTop: (overlayItem.offset().top) - scollElementTop
							}, 500);
							if(window.dataLayer) {
								var dataLayer = dataLayer || [];  
								dataLayer.push({ 
									\'event\': \'formInruilvoorstelSubmit\'								}); 															}	
							return;
						} else {
							jQuery(\'#ovis-aanvragen-\'+ovisObjectID).html(\'Aanvragen\').removeClass(\'processing\');
							jQuery(\'.ovis-invalid\').removeClass(\'ovis-invalid\');							
							if(response.errors.captcha){
								jQuery(\'#ovis-send-response\').removeClass(\'ovis-succes\').addClass(\'ovis-error\').html(txtOVISFoutVerzenden);
								jQuery(\'#ovis-contact-name\').val(\'\');
								jQuery(\'#ovis-contact-phone\').val(\'\');
								jQuery(\'#ovis-contact-sender\').val(\'\');
								jQuery(\'#ovis-contact-contactperson\').val(\'\');
								jQuery(\'#ovis-contact-message\').val(\'\');
							} else {
								jQuery(\'#ovis-send-response\').removeClass(\'ovis-succes\').addClass(\'ovis-error\').html(txtOVISFoutief);
								if(response.errors.name){
									jQuery(\'#ovis-contact-name\').addClass(\'ovis-invalid\');
								}
								if(response.errors.sender){
									jQuery(\'#ovis-contact-contactperson\').addClass(\'ovis-invalid\');
								}								
								if(response.errors.phone){									jQuery(\'#ovis-contact-phone\').addClass(\'ovis-invalid\');								}
								if(response.errors.soort){									jQuery(\'#ovis-contact-soort\').addClass(\'ovis-invalid\');								}
								if(response.errors.merk){
									jQuery(\'#ovis-contact-merk\').addClass(\'ovis-invalid\');
								}
								if(response.errors.model){
									jQuery(\'#ovis-contact-model\').addClass(\'ovis-invalid\');
								}
								if(response.errors.bouwjaar){									jQuery(\'#ovis-contact-bouwjaar\').addClass(\'ovis-invalid\');								}
								if(response.errors.conditie){
									jQuery(\'#ovis-contact-conditie\').addClass(\'ovis-invalid\');								}
								if(response.errors.schade){
									jQuery(\'#ovis-contact-schade\').addClass(\'ovis-invalid\');
								}
								if(response.errors.staatbekleding){
									jQuery(\'#ovis-contact-staatbekleding\').addClass(\'ovis-invalid\');
								}
								if(response.errors.staatbanden){									jQuery(\'#ovis-contact-staatbanden\').addClass(\'ovis-invalid\');								}
								if(response.errors.kenteken){
									jQuery(\'#ovis-contact-kenteken\').addClass(\'ovis-invalid\');								}								
								if(response.errors.kilometerstand){
									jQuery(\'#ovis-contact-kilometerstand\').addClass(\'ovis-invalid\');
								}
								if(response.errors.images){
									jQuery(\'#ovis-drag-drop-area\').addClass(\'ovis-invalid\');
								}
							}
							return;							
						}
						jQuery(\'#ovis-aanvragen-\'+ovisObjectID).html(\'Versturen\').removeClass(\'processing\');
						jQuery(\'#ovis-send-response\').removeClass(\'ovis-succes\').addClass(\'ovis-error\').html(txtOVISFoutVerzenden);
						return;
					});				
				}
				return false;
			};
		});
	</script>';	
}
add_action( 'wp_footer', 'send_inruil_javascript' );
function send_verhuur_javascript() {
	echo '<script type="text/javascript" >
		jQuery(document).ready(function($) {
			jQuery.sendOvisVerhuuraanvraag = function(ovisObjectID) {
				if(jQuery(\'#ovis-aanvragen-\'+ovisObjectID).hasClass(\'processing\')){
					return;
				}
				jQuery(\'#ovis-aanvragen-\'+ovisObjectID).html(\'verwerking\').addClass(\'processing\');			
				if(jQuery(\'#ovis-contactform-\'+ovisObjectID).length){
					var data = jQuery(\'#ovis-contactform-\'+ovisObjectID).serialize() + \'&action=send_verhuur\';					
					jQuery.post(my_ajax_object.ajax_url, data, function(response) {
						if(response.status === \'succes\') {
							jQuery(\'#ovis-send-response\').removeClass(\'ovis-error\').addClass(\'ovis-succes\').html(txtOVISAanvraagVerzonden);
							if(response.item != \'\') {
								jQuery(\'#ovis-contactform-\'+response.item).remove();
								jQuery(\'#ovis-aanvragen-\'+response.item).remove();
							}
							window.dataLayer = window.dataLayer || [];                                               
							window.dataLayer.push({
								\'event\':\'formContactSubmit\',
								\'contactType\':\'VerhuurAanvraagForm\',
							});
							var scollElement = jQuery(\'#ovis-container\').offset();
							var scollElementTop = scollElement.top;
							var overlayItem = jQuery(\'#ovis-action-form\');
							jQuery(\'html, body\').animate({
								scrollTop: (overlayItem.offset().top) - scollElementTop
							}, 500);
							if(window.dataLayer) {
								var dataLayer = dataLayer || [];  								
								dataLayer.push({ 
									\'event\': \'formVerhuuraanvraagSubmit\'
								}); 								
							}	
							return;
						} else {
							jQuery(\'#ovis-aanvragen-\'+ovisObjectID).html(\'Aanvragen\').removeClass(\'processing\');
							jQuery(\'.ovis-invalid\').removeClass(\'ovis-invalid\');
							if(response.errors.captcha){
								jQuery(\'#ovis-send-response\').removeClass(\'ovis-succes\').addClass(\'ovis-error\').html(txtOVISFoutVerzenden);
								jQuery(\'#ovis-contact-name\').val(\'\');
								jQuery(\'#ovis-contact-phone\').val(\'\');
								jQuery(\'#ovis-contact-sender\').val(\'\');
								jQuery(\'#ovis-contact-contactperson\').val(\'\');								jQuery(\'#ovis-contact-message\').val(\'\');	
							} else {
								jQuery(\'#ovis-send-response\').removeClass(\'ovis-succes\').addClass(\'ovis-error\').html(txtOVISFoutief);				
								if(response.errors.periodevan){
									jQuery(\'#ovis-contact-periodevan\').addClass(\'ovis-invalid\');
								}
								if(response.errors.periodetot){
									jQuery(\'#ovis-contact-periodetot\').addClass(\'ovis-invalid\');
								}
								if(response.errors.adres){
									jQuery(\'#ovis-contact-adres\').addClass(\'ovis-invalid\');
								}
								if(response.errors.city){
									jQuery(\'#ovis-contact-city\').addClass(\'ovis-invalid\');
								}
								if(response.errors.housenumber){
									jQuery(\'#ovis-contact-housenumber\').addClass(\'ovis-invalid\');
								}
								if(response.errors.zipcode){
									jQuery(\'#ovis-contact-zipcode\').addClass(\'ovis-invalid\');
								}							
								if(response.errors.name){
									jQuery(\'#ovis-contact-name\').addClass(\'ovis-invalid\');
								}
								if(response.errors.sender){
									jQuery(\'#ovis-contact-contactperson\').addClass(\'ovis-invalid\');
								}								
								if(response.errors.phone){
									jQuery(\'#ovis-contact-phone\').addClass(\'ovis-invalid\');
								}
							}
							return;							
						}
						jQuery(\'#ovis-aanvragen-\'+ovisObjectID).html(\'Versturen\').removeClass(\'processing\');
						jQuery(\'#ovis-send-response\').removeClass(\'ovis-succes\').addClass(\'ovis-error\').html(txtOVISFoutVerzenden);
						return;
					});								}
				return false;				
			};
		});
	</script>';
}
add_action( 'wp_footer', 'send_verhuur_javascript' );
function get_blocked_days_javascript() {

	echo '<script type="text/javascript" >
		jQuery(document).ready(function($) {
			function DisableSpecificDatesCalendar(date) {	
				var string = jQuery.datepicker.formatDate(\'dd-mm-yy\', date);
				unavailabledaysselect.split(\',\');
				if((unavailabledaysselect.indexOf(string) == -1 && unavailabledaysselect.indexOf(\'History\'+string) == -1) || unavailabledaysselect.indexOf(\'ChangeDayLast\'+string) > -1 || unavailabledaysselect.indexOf(\'ChangeDayFirst\'+string) > -1 ){			
					if(unavailabledaysselect.indexOf(\'ChangeDayLast\'+string) > -1){					
						return [true,\'available ChangeDayLast\',\'Wisseldag\'];					
					} else if(unavailabledaysselect.indexOf(\'ChangeDayFirst\'+string) > -1){
						return [true,\'available ChangeDayFirst\',\'Wisseldag\'];					
					} else {					
						return [true,\'available\',\'Beschikbaar\'];					
					}
				} else if(unavailabledaysselect.indexOf(\'History\'+string) == -1){				
					return [false,\'notAvailable\',\'Niet meer beschikbaar\'];	
				} else {
					return [false,\'notAvailableHistory\',\'Datum ligt in het verleden\'];	
				}	
			}
			jQuery.GetBlockedDays = function(ovisObjectID,ovisUserID,responedata,detailPage) {
				if(ovisObjectID == \'\'){
					return;
				}
				var data = {
					\'action\': \'blocked_days\',
					\'form_action\': \'get-blocked-days\',
					\'ovis-blocked-object\': ovisObjectID
				};				
				jQuery.post(my_ajax_object.ajax_url, data, function(response) {	
					if(responedata == \'calendar\'){
						var currentTimeFilter = new Date();
						var currentYearFilter = currentTimeFilter.getFullYear();
						var currentMonthFilter = currentTimeFilter.getMonth()+1;
						var nextYearFilter = currentYearFilter+1;
						var BeschikbaarMaxDateFilter = "31-12-"+nextYearFilter;
						var BeschikbaarMinDateFilter = "01"+"-"+currentMonthFilter+"-"+currentYearFilter;						unavailabledaysselect = response.blocked;
						if(jQuery( "#availabiltycalendar" ).length){
							jQuery( "#availabiltycalendar" ).datepicker({
								monthNames: ovismonthnames,
								monthNamesShort: ovismonthnamesshort,
								dayNamesMin: ovisdaynames,
								firstDay: 1,
								dateFormat: "dd-mm-yy",
								showOtherMonths: true,
								selectOtherMonths: false,
								nextText: "Volgende maand",
								prevText: "Vorige maand",
								changeMonth: false,
								changeYear: false,
								maxDate: BeschikbaarMaxDateFilter,
								minDate: BeschikbaarMinDateFilter,
								numberOfMonths: 3,
								beforeShowDay: DisableSpecificDatesCalendar
							});
						}						
					} else {
						jQuery.showOvisVerhuuraanvraagHTML(ovisObjectID,ovisUserID,responedata,response,detailPage);
					}
					return;
				});				
				return;				
			};
		});
	</script>';
}
add_action( 'wp_footer', 'get_blocked_days_javascript' );
function save_settings_javascript() {
	echo '<script type="text/javascript" >
		jQuery(document).ready(function($) {
			if(jQuery(\'#custom-css\').length > 0){				var cm_editor = wp.codeEditor.initialize(jQuery(\'#custom-css\'), {
					mode: \'text/css\'
				});	
			}
			jQuery(\'#submitform\').on(\'click\', function() {
				if(jQuery(\'#custom-css\').length > 0){
					var value = cm_editor.codemirror.getValue();					
					if(value != \'\'){
						jQuery(\'#custom-css\').val(value);
					} else {
						jQuery(\'#custom-css\').val(\'\');
					}
				}
				jQuery.validateInputs();			
				var submitbutton = jQuery(\'#form_settings .submit\');
				var containsubmitbuttonp = jQuery(\'#form_settings .contain-submit p.msg\');
				containsubmitbuttonp.css({ opacity: 0 });
				submitbutton.addClass(\'loading-padding\').delay(50).queue(function(next){
					jQuery(this).addClass(\'loading-image\');
					next();
				});
				var data = jQuery(\'#form_settings\').serialize() + \'&action=save_settings\';
				jQuery.post(ajaxurl, data, function(response) {					submitbutton.removeClass(\'loading-padding\').removeClass(\'loading-image\');
					if(response === "saved") {
						containsubmitbuttonp.html(\'Instellingen opgeslagen\');
					} else {
						containsubmitbuttonp.html(\'Er is een fout opgetreden\');
					}
					containsubmitbuttonp.delay(200).queue(function(next){
						jQuery(this).css({ opacity: 1 });
						next();
					});
				});
				return false;				
			});	
			jQuery(\'#submitcacheform\').on(\'click\', function() {
				var submitbutton = jQuery(\'#form_clear_cache .submit\');
				var containsubmitbuttonp = jQuery(\'#form_clear_cache .contain-submit p.msg\');
				containsubmitbuttonp.css({ opacity: 0 });
				submitbutton.addClass(\'loading-padding\').delay(50).queue(function(next){
					jQuery(this).addClass(\'loading-image\');
					next();
				});
				var data = jQuery(\'#form_clear_cache\').serialize() + \'&action=flush_ovis_cache\';
				jQuery.post(ajaxurl, data, function(response) {
					submitbutton.removeClass(\'loading-padding\').removeClass(\'loading-image\');
					if(response === "cleared") {						containsubmitbuttonp.html(\'Cache opgeschoond\');					} else {						containsubmitbuttonp.html(\'Er is een fout opgetreden\');					}
					containsubmitbuttonp.delay(200).queue(function(next){
						jQuery(this).css({ opacity: 1 });
						next();
					});
				});
				return false;
			});	
		});
	</script>';	
}
add_action( 'admin_footer', 'save_settings_javascript' );
function save_color_javascript() {
	echo '<script type="text/javascript" >
		jQuery(document).ready(function($) {
			processColor = function(form, message) {	
				var data = form.serialize() + \'&action=save_color\';
				jQuery.post(ajaxurl, data, function(response) {
					if(response === "saved") {
						message.html(\'Kleur opgeslagen\');
					} else {
						message.html(\'Er is een fout opgetreden\');
					}
					message.delay(200).queue(function(next) {
						jQuery(this).css({ opacity: 1 });
						next();
					});				
				});
			}		
		});
	</script>';
}
add_action( 'admin_footer', 'save_color_javascript' );
function save_settings() {
	global $wpdb;	
	require_once(plugin_dir_path(__FILE__) . 'inc_process.php');
	wp_die();
} 
add_action( 'wp_ajax_save_settings', 'save_settings' );
function flush_ovis_cache() {
	global $wpdb;
	require_once(plugin_dir_path(__FILE__) . 'inc_process.php');
	wp_die();
} 
add_action( 'wp_ajax_flush_ovis_cache', 'flush_ovis_cache' );
function save_color() {
	global $wpdb;
	require_once(plugin_dir_path(__FILE__) . 'inc_process.php');
	wp_die();
} 
add_action( 'wp_ajax_save_color', 'save_color' );
function user_content() {
	global $wpdb;
	require_once(plugin_dir_path(__FILE__) . 'inc_process.php');
	wp_die();
} 
add_action( 'wp_ajax_user_content', 'user_content' );
add_action( 'wp_ajax_nopriv_user_content', 'user_content' );
function more_filters() {
	global $wpdb;
	require_once(plugin_dir_path(__FILE__) . 'inc_process.php');
	wp_die();
} 
add_action( 'wp_ajax_more_filters', 'more_filters' );
add_action( 'wp_ajax_nopriv_more_filters', 'more_filters' );
function send_contact() {
	global $wpdb;	
	require_once(plugin_dir_path(__FILE__) . 'inc_process.php');
	wp_die();
} 
add_action( 'wp_ajax_send_contact', 'send_contact' );
add_action( 'wp_ajax_nopriv_send_contact', 'send_contact' );
function send_inruil() {
	global $wpdb;
	require_once(plugin_dir_path(__FILE__) . 'inc_process.php');
	wp_die();
} 
add_action( 'wp_ajax_send_inruil', 'send_inruil' );
add_action( 'wp_ajax_nopriv_send_inruil', 'send_inruil' );
function send_verhuur() {
	global $wpdb;
	require_once(plugin_dir_path(__FILE__) . 'inc_process.php');
	wp_die();
} 
add_action( 'wp_ajax_send_verhuur', 'send_verhuur' );
add_action( 'wp_ajax_nopriv_send_verhuur', 'send_verhuur' );function blocked_days() {
	global $wpdb;
	require_once(plugin_dir_path(__FILE__) . 'inc_process.php');
	wp_die();
} 
add_action( 'wp_ajax_blocked_days', 'blocked_days' );
add_action( 'wp_ajax_nopriv_blocked_days', 'blocked_days' );
function inruil_image() {
	global $wpdb;
	require_once(plugin_dir_path(__FILE__) . 'inc_process.php');   
	wp_die();
} 
add_action( 'wp_ajax_inruil_image', 'inruil_image' );
add_action( 'wp_ajax_nopriv_inruil_image', 'inruil_image' );
add_action('admin_enqueue_scripts', 'codemirror_enqueue_scripts');
function codemirror_enqueue_scripts($hook) {	
  $cm_settings['codeEditor'] = wp_enqueue_code_editor(array('type' => 'text/css'));
  wp_localize_script('jquery', 'cm_settings', $cm_settings);
  wp_enqueue_script('wp-theme-plugin-editor');
  wp_enqueue_style('wp-codemirror');
}
add_action('ovis_clean_cache', 'clean_ovis_cache');
function ovis_cache() {	
	$args = array( false );	
	if ( !wp_next_scheduled( 'ovis_clean_cache' ,$args) ) {
		wp_schedule_event( current_time( 'timestamp' ), 'hourly', 'ovis_clean_cache',$args);
    }	
}
add_action('wp', 'ovis_cache');
function clean_ovis_cache() {	
	$sImageURL = ABSPATH.'wp-content/cache/ovis/';
	if(is_dir($sImageURL)){
		$now   = time();
		foreach (scandir($sImageURL) as $file) {
			if ($file !== '.' && $file !== '..') {
				$iFileTime = filemtime($sImageURL.$file);				
				if(is_file($sImageURL.$file)){					if (($now - $iFileTime) >= (60 * 60 * 2)) {
						unlink($sImageURL.$file);
					}
				}
			}
		}
	}	
}